## lua-torch-trepl 0~20170619

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8 FATAL_ERROR)
CMAKE_POLICY(VERSION 2.8)

FIND_LIBRARY(Readline REQUIRED)
FIND_PACKAGE(Torch REQUIRED)

INCLUDE_DIRECTORIES("${CMAKE_CURRENT_SOURCE_DIR}")
INCLUDE_DIRECTORIES("${LUA_INCDIR}")
LINK_DIRECTORIES("${LUA_LIBDIR}")
LINK_DIRECTORIES("${LIBDIR}")

# TODO
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckLibraryExists)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Check system packages to be installed
IF (UNIX OR NOT WIN32)
  CHECK_INCLUDE_FILES(stdlib.h HAVE_STDLIB_H)
ENDIF (UNIX OR NOT WIN32)

CONFIGURE_FILE("utils.c" "${CMAKE_CURRENT_SOURCE_DIR}/treplutils.c")
# C source files
SET(src 
  "${CMAKE_CURRENT_SOURCE_DIR}/readline.c"
  "${CMAKE_CURRENT_SOURCE_DIR}/treplutils.c" )

# LUA source files
SET(luasrc 
  "${CMAKE_CURRENT_SOURCE_DIR}/init.lua"
  "${CMAKE_CURRENT_SOURCE_DIR}/colorize.lua"
  "${CMAKE_CURRENT_SOURCE_DIR}/colors.lua" )

# Th executable script -> CLI for Torch
SET(scriptsrc
    "${CMAKE_CURRENT_SOURCE_DIR}/th")

# When using MSVC
IF(MSVC)
  # we want to respect the standard, and we are bored of those **** .
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE=1)
ENDIF(MSVC)

ADD_LIBRARY("treplutils" SHARED ${src})

# OUTPUT_NAME "treplutils"
# We would like to rename util.c to treputils.so after compilation and without prefix lib
SET_TARGET_PROPERTIES("treplutils" PROPERTIES
  PREFIX ""
  IMPORT_PREFIX "lib" )

# Apple related stuff
IF(APPLE)
  SET_TARGET_PROPERTIES("treplutils" PROPERTIES
    LINK_FLAGS "-undefined dynamic_lookup")
ENDIF()

# Install LUA source files
INSTALL(FILES ${luasrc} DESTINATION ${LUADIR}/trepl)
# Install compiled C libraries
INSTALL(TARGETS treplutils LIBRARY DESTINATION ${LUA_LIBDIR} )
IF(LUALIB)
  TARGET_LINK_LIBRARIES(treplutils ${LUALIB} readline)
ENDIF()
# Install cli script
INSTALL(PROGRAMS ${scriptsrc} DESTINATION ${LUA_BINDIR})

## lua-torch-trepl 0~20170619-ge5e17e3

=== debian/changelog ===
lua-torch-trepl (0~20170619-ge5e17e3-7) unstable; urgency=medium

  * Add watch file to monitor upstream master branch.
  * Bump Standards-Verstion to 4.1.4 . (no change)

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 21 Apr 2018 03:34:54 +0000

lua-torch-trepl (0~20170619-ge5e17e3-6) unstable; urgency=medium

  * Change Architecture of torch-trepl to all.
    The i386 build was enabled for the lua-torch-torch7 package, which
    means the package should be able to migrate.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 22 Feb 2018 08:30:37 +0000

lua-torch-trepl (0~20170619-ge5e17e3-5) unstable; urgency=medium

  * Bump debhelper compat to 11.
  * Bump Standards-Version to 4.1.3 (no change).
  * Change Architecture of torch-trepl from all to any.
  * Fix insecure-copyright-format-uri.
  * Update Vcs-* links to salsa.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 20 Jan 2018 06:46:55 +0000

lua-torch-trepl (0~20170619-ge5e17e3-4) unstable; urgency=medium

  * tests: Ignore tput error message to avoid autopkgtest failure.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 19 Nov 2017 03:12:19 +0000

lua-torch-trepl (0~20170619-ge5e17e3-3) unstable; urgency=medium

  * Update B-D to prevent build on unsupported architectures.
  * Move several suggested packages to Depends, because they
    are require'd by the init.lua script.
  * Update my name in control and copyright.
  * Bump Standards-Version to 4.1.1 . No change needed.
  * rules: Don't set DEB_HOST_MULTIARCH again.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 28 Oct 2017 13:59:50 +0000

lua-torch-trepl (0~20170619-ge5e17e3-2) unstable; urgency=medium

  * Generate the links file from rules, instead of using a template.
  * Change ' to " in tests control file to work around autopkgtest bug.
  * Upload to unstable.

 -- Zhou Mo <cdluminate@gmail.com>  Sat, 26 Aug 2017 15:49:13 +0000

lua-torch-trepl (0~20170619-ge5e17e3-1) experimental; urgency=medium

  * Import snapshot.
  * Bump Standards-Version to 4.0.0 (requires no change).
  * Add autopkgtest control file.

 -- Zhou Mo <cdluminate@gmail.com>  Sat, 29 Jul 2017 02:04:14 +0000

lua-torch-trepl (0~20161111-gf588b72-3) experimental; urgency=medium

  * Fix lintian Error by restoring #DEB_HOST_MULTIARCH# in
    lua-torch-trepl.links which was changed by mistake.

 -- Zhou Mo <cdluminate@gmail.com>  Wed, 24 May 2017 07:20:40 +0000

lua-torch-trepl (0~20161111-gf588b72-2) experimental; urgency=medium

  * Debhelper compat 10.
  * For binary packages luajit is prior to lua5.1 as dependency.
  * Update patch: debian-customize-banner .

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 22 May 2017 04:12:58 +0000

lua-torch-trepl (0~20161111-gf588b72-1) experimental; urgency=medium

  * New upstream snapshot.
  * Refresh patch: debian-customize-banner.

 -- Zhou Mo <cdluminate@gmail.com>  Thu, 17 Nov 2016 09:15:07 +0000

lua-torch-trepl (0~20160613-g06128f9-3) experimental; urgency=medium

  * Change B-D libreadline6-dev -> libreadline-dev.
  * Fix typo in short package descriptions. (Troch -> Torch)
  * Add a few comments in packaging files.

 -- Zhou Mo <cdluminate@gmail.com>  Thu, 06 Oct 2016 11:05:06 +0000

lua-torch-trepl (0~20160613-g06128f9-2) experimental; urgency=medium

  * Fix hardcoded multiarch triplet in lua-torch-trepl.links .

 -- Zhou Mo <cdluminate@gmail.com>  Sat, 24 Sep 2016 06:37:51 +0000

lua-torch-trepl (0~20160613-g06128f9-1) experimental; urgency=low

  * Initial release. Closes: #826791

 -- Zhou Mo <cdluminate@gmail.com>  Thu, 25 Aug 2016 12:15:18 +0000

=== debian/control ===
Source: lua-torch-trepl
Section: interpreters
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <cdluminate@gmail.com>
Build-Depends: cmake,
               debhelper (>=11~),
               dh-lua,
               libreadline-dev,
# these lua-* packages are runtime dependencies
               lua-penlight,
               lua-torch-torch7,
               libtorch-th-dev,
Standards-Version: 4.1.4
Homepage: https://github.com/torch/trepl
Vcs-Browser: https://salsa.debian.org/science-team/lua-torch-trepl
Vcs-Git: https://salsa.debian.org/science-team/lua-torch-trepl.git

Package: lua-torch-trepl
Architecture: any
Multi-Arch: same
Depends: lua-penlight,
         lua-torch-sys,
         lua-torch-xlua,
         lua-torch-torch7,
         luajit | lua5.1,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: lua-torch-dok,
XB-Lua-Versions: ${lua:Versions}
Description: REPL Package for Torch Framework
 A pure Lua REPL (Read,Eval,Print-Loop) for LuaJIT, with heavy
 support for Torch types. It uses Readline for tab completion.
 .
 This package contains backend files to support the command line
 frontend 'th'.

Package: torch-trepl
Architecture: all
Multi-Arch: foreign
Depends: lua-torch-trepl (>= ${source:Version}),
         lua-torch-trepl (<< ${source:Version}.1~),
         luajit | lua5.1, ${misc:Depends}
Description: REPL Wrapper Package for Torch Framework
 A pure Lua REPL (Read,Eval,Print-Loop) for LuaJIT, with heavy
 support for Torch types. It uses Readline for tab completion.
 .
 This package also installs command line frontend `th`, which
 comes packed with all these features:
 .
  * Tab-completion on nested namespaces
  * Tab-completion on disk files (when opening a string)
  * History
  * Pretty print (table introspection and coloring)
  * Auto-print after eval (can be stopped with ;)
  * Each command is profiled, timing is reported
  * No need for '=' to print
  * Easy help with: `? funcname`
  * Self help: `?`
  * Shell commands with: $ cmd (example: `$ ls`)
  * Print all user globals with `who()`
  * Import a package's symbols globally with `import(package)`
  * Require is overloaded to provide relative search paths:
      `require('./mylocallib/')`
  * [Optional] strict global namespace monitoring
  * [Optional] async repl

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS= hardening=+all

%:
	dh $@ --buildsystem=lua --with lua

generate_install_links:
# See top part of init.lua,
# readline.so is required to enable tab-completion functionality
# of trepl, however the object file readline.* is compiled into
# treplutils.so, so we link treplutils.so to readline.so, or
# the tab-completion will be broken.
	echo "usr/lib/$(DEB_HOST_MULTIARCH)/lua/5.1/treplutils.so usr/lib/$(DEB_HOST_MULTIARCH)/lua/5.1/readline.so" \
		> debian/lua-torch-trepl.links

override_dh_auto_configure: generate_install_links
	ln -s . trepl
	dh_auto_configure

override_dh_auto_clean:
	-$(RM) -rf 5.1-torch-trepl 5.2-torch-trepl debian/trash trepl
	dh_auto_clean

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=0~%cd-g%h" \
https://github.com/torch/trepl \
HEAD debian uupdate
